Bug 17205 - THEAD & TFOOT should be printed on every page
Summary: THEAD & TFOOT should be printed on every page
Status: NEW
Alias: None
Product: WebKit
Classification: Unclassified
Component: Printing (show other bugs)
Version: WebKit Nightly Build
Hardware: All All
: P2 Enhancement
Assignee: Nobody
URL: http://www.syncbyte.com/Listendruck.html
Keywords: InRadar
: 34218 143330 (view as bug list)
Depends on:
Blocks:
 
Reported: 2008-02-07 00:40 PST by Rene Trost
Modified: 2017-02-03 04:41 PST (History)
81 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Rene Trost 2008-02-07 00:40:11 PST
When printing long tables with Safari, the THEAD and TFOOT sections of a table are only printed on the first page. 

The THEAD & TFOOT section of a table should be printed on every page, like suggested by W3C:
http://www.w3.org/TR/html401/struct/tables.html#h-11.2.3
Comment 1 Robert Blaut 2008-02-07 04:48:29 PST
To be clear. The above mentioned specification states:

"When long tables are printed, the table head and foot information "may be" repeated on each page that contains table data."

So it "may be" printed. Not "should be" printed. But to be consistent with other browsers like IE, Firefox that have this feature implemented I agree it should be implemented. 
Comment 2 Rene Trost 2008-02-08 12:26:17 PST
(In reply to comment #1)

Would be nice to see it implemented. It really helps to read multi page reports and gives the opportunity  to print only selected pages without losing the column titles. 
Comment 3 Barrett 2009-02-11 08:45:07 PST
Bump.  This would be a really nice feature?  Any thoughts or progress?
Comment 4 Rene Trost 2009-02-15 18:20:15 PST
Nope :/ Safari and Opera still don't support this feature but Firefox and MS-Explorer do.
Comment 5 David Richardson 2009-04-16 17:56:50 PDT
Yes, the specification says "may be" printed on every page, rather than "shall be" or "must be".

This goes beyond consistency with other browsers.
Without repeating table headers and footers, Webkit is unsuited for any line-of-business application which requires the printing of tabular content - which is to say virtually all such applications.
Comment 6 Rene Trost 2010-05-09 00:25:45 PDT
2 years later and still no solution on the horizon? Web based business applications become more and more important and Safari is just out of that area because of missing key features?
Comment 7 Alexey Proskuryakov 2012-04-03 08:50:58 PDT
*** Bug 34218 has been marked as a duplicate of this bug. ***
Comment 8 Raphael Randschau 2012-06-23 14:46:22 PDT
Are there any plans to move this change request forward? It's been around some years now and it's really a major annoyance. At least to me. 

I've read somewhere that a potential fix is quite easy, while others state that only a major rewrite will do. Any hints into what direction this might go?

Best regards,
Raphael
Comment 9 Ondřej Daněk 2012-08-22 01:07:34 PDT
The same problem, please do something about it. THX
Comment 10 JC 2012-08-23 03:08:04 PDT
A big lacking feature in Webkit, especially since it is used in Qt, and not added after 4 years. Can it become a priority ?
Comment 11 Howard Keziah 2012-10-09 12:05:29 PDT
Lacking this feature prevents webkit from producing great printed results. Please add.
Comment 12 Pascal 2012-12-01 12:17:06 PST
Adding my support for this, some wizard should give it a shot!
Comment 13 Mel Adamei 2013-01-03 09:50:14 PST
I would also like to see a fix for this.  Is there any way that thead and tfoot can just be pulled into the header and footer area so that it repeats on each page?  Is that viable at all?  Or do the page dimensions need to be altered and moved around?
Comment 14 Rainabba 2013-01-03 09:52:36 PST
I want to confirm that this behavior is a MUST for LOB web applications because otherwise printing professional looking content from an otherwise incredibly powerful system is near impossible. I've never submitted patches to an open source project but I'm going to take a look because it would require FAR less work and money than the alternatives that my company faces to maintain IE support (most HTML to PDF components use WebKit).
Comment 15 Kim Tranjan 2013-01-18 16:12:17 PST
Seriously, it's an important feature. Reported since 2008, come on!
Comment 16 David Dixon 2013-01-31 12:30:07 PST
I would also like to see this feature implemented. Printed media CSS support is rather lacking on webkit vs others, and with solutions such as wkhtmltopdf becoming more popular, this is becoming something of a necessity for some.
Comment 17 Shaun Donnelly 2013-02-25 01:34:39 PST
+1 for this - As a user of wkhtmltopdf this would be very useful for itemised invoice tables.
Comment 18 Jean-Élie 2013-03-20 06:16:23 PDT
It should be implemented!!!
Comment 19 ECC-Dan 2013-03-20 06:18:47 PDT
This issue is the 14th most voted issue in chromium, with 471 votes.

It's sad that this works in IE and FF but not webkit; We have clients asking for this feature and all we can say is "use another browser just for this task", when we would normally tell them to use chrome.

https://code.google.com/p/chromium/issues/detail?id=24826
Comment 20 Oliver Kohll 2013-04-05 04:50:22 PDT
Just a note that I'd like to vote for this issue - we'd like to generate a PDF printout from Safari with headers and footers, this is impeding us.
Comment 21 PR 2013-05-16 01:38:48 PDT
Chrome is really good to work ,but only for this we plan to use other browser.
why chrome team making such delay  to add this feature to chrome .
Comment 22 a1533202 2013-09-20 11:26:19 PDT
Any position fixed element should be printed in every page, like Firefox and Internet Explorer do.
Comment 23 a1533202 2013-09-20 11:38:00 PDT
(In reply to comment #22)
> Any position fixed element should be printed in every page, like Firefox and Internet Explorer do.

"... In the case of the print media type, the box is rendered on every page, and is fixed with respect to the page box, even if the page is seen through a viewport (in the case of a print-preview, for example). ..."

http://www.w3.org/TR/CSS2/visuren.html#propdef-position
Comment 24 Ajit Parida 2013-12-10 22:36:31 PST
5 years later and still no solution .
header and footer element should be printed in every page, like Firefox and Internet Explorer.
Comment 25 Ajit Parida 2013-12-10 22:37:42 PST
I also add my votes to this bug.
Comment 26 Joël Grand-Guillaume 2013-12-20 05:18:49 PST
I also vote to fix this annoying issue please.
Comment 27 Raja Chandramohan 2014-02-24 02:03:13 PST
As we are highlighting the customers use only chrome as it is fast and user friendly.. on the big time feature which is not fixed for long time.. is really paining. Please fix as early as possible to command our customers to go ahead with Chrome as better browser.
Comment 28 Jon 2014-03-20 12:53:30 PDT
Is there any progress on this bug? It seems that this is a pretty widely used function and it is a shame that Chrome and Safari do not support it correctly.
Comment 29 Adam Rackis 2014-03-31 14:20:04 PDT
"Me too"

Hello?  Is there any marginally intelligent reason why the most powerful technology company in the world can't solve this rather important issue after over *SIX* years? 

P A T H E T I C
Comment 30 Michael 2014-04-09 07:44:27 PDT
+1 seriously
Comment 31 Rainabba 2014-04-09 13:58:37 PDT
I have a MUCH better idea. How about just implementing proper print support with CSS Paged Media Modules Level 3? http://www.w3.org/TR/css3-page/
Comment 32 Luiz Santos 2014-07-29 01:37:57 PDT
please, solve this issue
Comment 33 ramezashraf 2014-08-04 06:25:21 PDT
What's taking so long ?!
SERIOUSLY !
FEB 2008 TO AUGUST 2014 AND COUNTING
6.5 YEARS !!

Just SAD.
Comment 34 shallowbastard 2014-08-20 01:45:44 PDT
+1 C'mon guys, even IE handles this properly!
Comment 35 aleh.autushka 2014-09-14 08:41:22 PDT
+ 1, Our company needs this feature also.
Comment 36 camila 2014-10-22 05:26:40 PDT
I need this, even on IE it works.
Comment 37 Jose Abadie 2014-10-30 11:54:31 PDT
Hi! Any workaround??? I really need this!!!
Comment 38 John Huss 2014-12-02 14:19:57 PST
+1 this would be very helpful to have.
Comment 39 Ed Sanford 2014-12-10 09:29:02 PST
+1 we need a header block that repeats across pages.  The THEAD (or css equivalent) that works in IE and mostly works in FF, is already part of the html 4 spec (and presumably inherited by html 5).  

It would be okay for other methods to work, as long as something does.  

For example: In FF I combine header {position:fixed} with an html {margin-top}, to avoid the problems with some odd/complex arrangements crashing it when using body{display:table} header{display:table-header-group} and having several actual/nested tables on the same page.  

In IE body{display:table} header{display:table-header-group} works correctly.

This stable functionality would be a good target for WebKit.  As, it already mostly works in Gecho, perhaps capping iterations or putting some other safeguard in place would make the code usable in WebKit (otherwise) as is.

As, WebKit is forked from Gecho, copying code from Gecko should not be a huge undertaking.  As the Gecko bug is for a limited set of circumstances, placing limits on execution should be sufficient for now - to prevent the Gecko bugs from emerging in WebKit.
Comment 40 Pascal 2014-12-10 09:33:42 PST
(In reply to comment #39)

Nitpick: WebKit is not forked from Gecko but stems from KHTML.

> As, WebKit is forked from Gecho, copying code from Gecko should not be a
> huge undertaking.  As the Gecko bug is for a limited set of circumstances,
> placing limits on execution should be sufficient for now - to prevent the
> Gecko bugs from emerging in WebKit.
Comment 41 Ed Sanford 2014-12-11 08:00:06 PST
+1 I stand corrected.  I still need the functionality though.
If nothing else, can you at least make html {margin-top and/or padding-top} and header {position:fixed} repeat on each printed page.  That would be good for a start.  And handling {table-header-group} and/or thead/tfoot correctly would be ideal.
Comment 42 Bob Lail 2015-01-27 06:13:21 PST
+1
Comment 43 Declan Frye 2015-02-16 13:30:40 PST
+1 for adding this functionality.
Comment 44 Manuel Canepa 2015-02-25 04:50:43 PST
+1
Comment 45 mash 2015-03-05 06:16:37 PST
+1
Comment 46 m.kurz+webkitbugs 2015-03-05 06:19:04 PST
+1
Comment 47 nazgul17 2015-03-07 21:04:07 PST
+1 can anybody explain what is so difficoult about this?
Comment 48 Kate 2015-03-09 23:45:19 PDT
+1 Please fix
Comment 49 Cristi Teodoreanu 2015-03-11 04:09:49 PDT
+1 should be fixed
Comment 50 kyle 2015-03-20 08:36:22 PDT
+1
Comment 51 matteo 2015-03-25 10:06:20 PDT
+1
Comment 52 Willem Laan 2015-03-26 11:12:44 PDT
+1
Comment 53 SP 2015-04-14 02:47:09 PDT
+1. This has dragged on for far too long.
Comment 54 riebbels.kristof 2015-04-15 06:42:40 PDT
+1
Comment 55 Bruno Brittz 2015-05-06 11:12:59 PDT
+1
Comment 56 Faisal Chishti 2015-05-22 16:14:17 PDT
The issue is still there to be worked on. C'mon.
Comment 57 yanick.rochon 2015-06-18 12:13:55 PDT
Just stumbled across this. As seen on SO and just about everywhere, this issue puts to shame Chrome.

... 7 years and no update has been done with this? I mean, even a basic, half-broken implementation would be better than nothing.

And since Chrome actually generates PDF when printing, I mean, come on! How hard can it be to just insert the <thead> container before adding new rows?
Comment 58 Jimmy 2015-07-01 13:07:04 PDT
Wow, we recommend Chrome to all of our clients at work.  But after not being able to include the header of my table in my print out on every page I am not sure that will be an option.

Please fix this!
Comment 59 Thomas J. Webb 2015-07-03 13:55:50 PDT
+1

The lack of this feature is making me seriously consider embedding Gecko despite the app being Qt and already having webkit embedded. It's vital for business and legal requirements and it shows that chrome, safari, et al. aren't suitable for certain business purposes.
Comment 60 Artur 2015-07-05 07:11:01 PDT
+1
This is a very important feature.
I cant recommend using webkit based browsers because of this issue.
Comment 61 joaomelont 2015-07-27 12:52:24 PDT
+1

Really frustrating when you make a revolution in your company exalting Chrome, and after some good results, you end up in this.
Comment 62 p3dro 2015-08-14 01:01:08 PDT
Our customers are using Chrome, but this prevents important feature not to work as expected and we must suggest them to use FF or even IE before Chrome. I'd be interested to hear as well what's so hard about making the fix?
Comment 63 AK 2015-11-04 23:52:31 PST
Any magic happening ???
Comment 64 brian.edwards 2015-12-16 10:49:59 PST
Please fix!!!!!!  Soon !!
Comment 65 Hiep Phan 2016-01-17 20:01:07 PST
so, 2016 and still no solution for this very old issues?
Comment 66 jbuck 2016-03-23 08:46:58 PDT
Still a issues as of 3/16/2016  Chrome version 49.xx
Comment 67 kannanfa 2016-04-21 06:27:05 PDT
What a wonderful bug. Still 21/04/2016.
Comment 68 Bharat 2016-05-14 07:57:21 PDT
+1
Comment 69 Chris Rebert 2016-06-05 12:26:55 PDT
Fixed in Chrome (as long as you use `break-inside:avoid;`):
https://bugs.chromium.org/p/chromium/issues/detail?id=24826#c45
Comment 70 Chris Rebert 2016-06-05 12:50:23 PDT
*** Bug 143330 has been marked as a duplicate of this bug. ***
Comment 71 m.kurz+webkitbugs 2016-06-05 12:52:09 PDT
Now as this is fixed in Chrome I hope WebKit will catch up soon!
Comment 72 John 2016-06-08 23:35:34 PDT
Please fix this bug. It is very useful. 
I hope it is fixed soon.. Chrome has fixed this bug. Please fix in webkit source.
https://codereview.chromium.org/2021703002/#ps1
Comment 73 John 2016-06-12 21:16:19 PDT
+1
Comment 74 John 2016-06-20 00:05:39 PDT
Is it fixable or not?
Is anyone working around this?
Comment 75 John 2016-06-20 20:57:55 PDT
Any update on this??
Comment 76 matteo 2016-08-19 08:53:52 PDT
Is it real?? In 2016 No solution to this bug??
Comment 77 Etienne Pilon 2016-08-28 12:49:33 PDT
8 years .. still not fix ?
Comment 78 matteo 2016-11-23 03:33:04 PST
Is there anyone that read these bug comments and can explain why no one can start solve this? Is it so difficult??
Comment 79 Mehdi Yeganeh 2017-01-07 23:38:15 PST
+1
Comment 80 akatijs 2017-01-16 11:13:42 PST
+1
Comment 81 RajendraPrasad 2017-02-03 04:41:09 PST
Any update on including header and footer of a table in my print out on every page.